## UDP Client/Server Overview

![](../assets/udp1.PNG)

**Datagram-based** 

* Connectionless
* unreliable \(no ordering of data\)
* can broadcast 
* Higher performance \(used in games, etc.\)

**Applications usually message-based** 

* No transport-layer retries 
* Applications handle \(or ignore\) errors 

**Processes identified by port number** 

**UDP Services live at specific ports** 

* Usually below 1024, requiring privilege

![](../assets/udp22.PNG)

![](../assets/udp33.PNG)

---

## Order of Operations

![UDP Client/Server](../assets/udp1.PNG)

* **socket\(\)** – Get a socket descriptor
* **bind\(\)** – Specify SOURCE port \(Optional for client/sender, Mandatory server/receiver\)
* **sendto\(\)/recvfrom\(\)** – _Data transfer\*_
* **close\(\)** – Close the socket

\(A UDP socket exists independently of any specific remote IP/PORT\)

* Both sending and receiving data occur on the same socket, even to/from different remote hosts.

You must track the source of incoming data and destination of outgoing data

* This info must be passed to **sendto\(\)** and is returned by **recvfrom\(\)**

It's usually easier to think of them as **"Senders"** and **"Receivers“**.

* If you want to receive traffic, you need bind to a port.

**recvfrom\(\)** returns a tuple of TWO values, the data and a tuple of remote ip/port.

**sendto\(\)** takes a tuple of TWO arguments, data and a tuple of the remote ip/port.

Use the client IP from **recvfrom\(\)** in the call to **sendto\(\)** to return data to that host.

You may use multiple assignments here as well:

### _data, remote = sock.recvfrom\(\)_

## Multiple Assignment:

`ret = sock.recvfrom()`

`ret[0] # The data`

`ret[1] # tuple of remote ip/port`

`data, remote = sock.recvfrom()`

---


![UDP Client/Server](../assets/udp-client-server.png)
Graphic and more information available [here](https://pythontic.com/modules/socket/udp-client-server-example)
